/*
 * @(#)kanji.c	1.10 Jun.30,1993
 *
 * ޤ󡣤Ūʳλѡۤ¤ߤޤ
 * (C) yamasita@omronsoft.co.jp
 */

#include	<stdio.h>

#include	"nntp.h"
#include	"gn.h"

mc_puts(sp)
unsigned char *sp;
{
	unsigned char dest[2048];
	unsigned char buf[2048];
	register unsigned char *dp,*bp;

	if ( display_kanji_code == internal_kanji_code ){
		dp = sp;
	} else {
		kanji_convert(internal_kanji_code,sp,display_kanji_code,dest);
		dp = dest;
	}

	bp = buf;

	while( *dp != 0 ) {
		if ( *dp == '\\' ) {
			if ( dp[1] == 'n' ) {
				*bp++ = NL;
				dp += 2;
				continue;
			}
			if ( dp[1] == '\\' ) {
				*bp++ = '\\';
				dp += 2;
				continue;
			}
			if ( dp[1] == '0' && dp[2] == '0' && dp[3] == '7' ) {
				*bp++ = BEL;
				dp += 4;
				continue;
			}
		}
		*bp++ = *dp++;
	}
	*bp = 0;

	printf("%s",buf);
}


	
kanji_convert(s_code,sp,d_code,dp)
int	s_code;						/* ϴ */
register unsigned char *sp;		/* ʸ */
int	d_code;						/* ϴ */
register unsigned char *dp;		/* ʸ */
{
	if ( s_code == d_code ) {
		strcpy(dp,sp);
	} else {
		switch (s_code) {
		case EUC:
			switch (d_code){
			case SJIS:
				euctosjis(sp,dp);
				break;
			default:	/* JIS */
				euctojis(sp,dp);
				break;
			}
			break;
		case SJIS:
			switch (d_code){
			case EUC:
				sjistoeuc(sp,dp);
				break;
			default:	/* JIS */
				sjistojis(sp,dp);
				break;
			}
			break;
		default:	/* JIS */
			switch (d_code){
			case SJIS:
				jistosjis(sp,dp);
				break;
			default:
				jistoeuc(sp,dp);
				break;
			}
			break;
		}
	}
}


/*
 * EUC -> JIS Ѵ
 */
euctojis(sp,dp)
register unsigned char *sp;		/*  EUC ʸ */
register unsigned char *dp;		/*  JIS ʸ */
{
	int	kanji_flag = 0;

	while( *sp != 0 ) {
		/* ASCII */
		if ( *sp <= DEL ){
			if ( kanji_flag == 1 ){
				*dp++ = ESC;
				*dp++ = '(';
				*dp++ = 'J';
				kanji_flag = 0;
			}
			*dp++ = *sp++;
			continue;
		}
		/* Ⱦѥ */
		if ( *sp == SS2 ) {
			sp += 2;
			mc_puts("\nȾѥʤѤƤޤ̵뤷ޤ\n\007");
			continue;
		}
		/*  */
		if ( kanji_flag == 0 ){
			*dp++ = ESC;
			*dp++ = '$';
			*dp++ = 'B';
			kanji_flag = 1;
		}
		*dp++ = *sp++ & 0x7f;
		*dp++ = *sp++ & 0x7f;
	}
	if ( kanji_flag == 1 ){
		*dp++ = ESC;
		*dp++ = '(';
		*dp++ = 'J';
	}
	*dp = 0;
}

/*
 * JIS -> EUC Ѵ
 */
jistoeuc(sp,dp)
register unsigned char *sp;		/*  JIS ʸ */
register unsigned char *dp;		/*  EUC ʸ */
{
	int	kanji_flag = 0;
	
	while( *sp != 0 ) {
		/* ץ󥹤Ƚ */
		if ( *sp == ESC ) {
			if ( sp[1] == '$' && ( sp[2] == '@' || sp[2] == 'B' ) ) {
				kanji_flag = 1;
				sp += 3;
				continue;
			}
			if ( sp[1] == '(' &&
				(sp[2] == 'B' || sp[2] == 'H' || sp[2] == 'J' ) ) {
				kanji_flag = 0;
				sp += 3;
				continue;
			}
		}
		/* ASCII */
		if ( kanji_flag == 0 ) {
			*dp++ = *sp++;
			continue;
		}
		/*  */
		*dp++ = *sp++ | 0x80;
		*dp++ = *sp++ | 0x80;
	}
	*dp = 0;
}

/*
 * SJIS -> JIS Ѵ
 */
sjistojis(sp,dp)
register unsigned char *sp;		/*  SJIS ʸ */
register unsigned char *dp;		/*  JIS ʸ */
{
	int	kanji_flag = 0;
	register int jupper,jlower,supper,slower;

	while( *sp != 0 ) {
		/* ASCII */
		if ( *sp <= 0x7f ){
			if ( kanji_flag == 1 ){
				*dp++ = ESC;
				*dp++ = '(';
				*dp++ = 'J';
				kanji_flag = 0;
			}
			*dp++ = *sp++;
			continue;
		}
		/* Ⱦѥ */
		if ( 0xa0 <= *sp && *sp <= 0xdf ){
			sp += 2;
			mc_puts("\nȾѥʤѤƤޤ̵뤷ޤ\n\007");
			continue;
		}
		/*  */
		if ( kanji_flag == 0 ){
			*dp++ = ESC;
			*dp++ = '$';
			*dp++ = 'B';
			kanji_flag = 1;
		}

		supper = *sp++;
		slower = *sp++;

		if(slower <= 0x9E){
			if( supper <= 0x9F )
				jupper = (supper-0x71) * 2 + 1;
			else
				jupper = (supper-0xB1) * 2 + 1;
			jlower = slower - 0x1F;
			if ( slower >= 0x80 )
				jlower--;
		} else {
			if( supper <= 0x9F )
				jupper = (supper-0x70) * 2;
			else
				jupper = (supper-0xB0) * 2;
			jlower = slower - 0x7E;
		}
		*dp++ = jupper;
		*dp++ = jlower;
	}
	if ( kanji_flag == 1 ){
		*dp++ = ESC;
		*dp++ = '(';
		*dp++ = 'J';
		kanji_flag = 0;
	}
	*dp = 0;
}

/*
 * JIS -> SJIS Ѵ
 */
jistosjis(sp,dp)
register unsigned char *sp;		/*  JIS ʸ */
register unsigned char *dp;		/*  SJIS ʸ */
{
	int	kanji_flag = 0;
	register int jupper,jlower,supper,slower;
	
	while( *sp != 0 ) {
		/* ץ󥹤Ƚ */
		if ( *sp == ESC ) {
			if ( sp[1] == '$' && ( sp[2] == '@' || sp[2] == 'B' ) ) {
				kanji_flag = 1;
				sp += 3;
				continue;
			}
			if ( sp[1] == '(' &&
				(sp[2] == 'B' || sp[2] == 'H' || sp[2] == 'J' ) ) {
				kanji_flag = 0;
				sp += 3;
				continue;
			}
		}
		/* ASCII */
		if ( kanji_flag == 0 ) {
			*dp++ = *sp++;
			continue;
		}
		/*  */
		jupper = *sp++;
		jlower = *sp++;

		if( jupper <= 0x5E )
			supper = (jupper-1) / 2 + 0x71;
		else
			supper = (jupper-1) / 2 + 0xB1;

		if( jupper & 1 ){
			slower = jlower + 0x1F;
			if( slower >= 0x7F )
				slower++;
		} else {
			slower = jlower + 0x7E;
		}
		*dp++ = supper;
		*dp++ = slower;
	}
	*dp = 0;
}

/*
 * EUC -> JIS Ѵ
 */
euctosjis(sp,dp)
register unsigned char *sp;		/*  EUC ʸ */
register unsigned char *dp;		/*  SJIS ʸ */
{
	register int jupper,jlower,supper,slower;

	while( *sp != 0 ) {
		/* ASCII */
		if ( *sp <= 0x7f ){
			*dp++ = *sp++;
			continue;
		}
		/* Ⱦѥ */
		if ( *sp == SS2 ) {
			sp += 2;
			mc_puts("\nȾѥʤѤƤޤ̵뤷ޤ\n\007");
			continue;
		}
		/*  */
		jupper = *sp++ & 0x7f;
		jlower = *sp++ & 0x7f;

		if( jupper <= 0x5E )
			supper = (jupper-1) / 2 + 0x71;
		else
			supper = (jupper-1) / 2 + 0xB1;

		if( jupper & 1 ){
			slower = jlower + 0x1F;
			if( slower >= 0x7F )
				slower++;
		} else {
			slower = jlower + 0x7E;
		}
		*dp++ = supper;
		*dp++ = slower;
	}
	*dp = 0;
}

/*
 * SJIS -> EUC Ѵ
 */
sjistoeuc(sp,dp)
register unsigned char *sp;		/*  SJIS ʸ */
register unsigned char *dp;		/*  euc ʸ */
{
	register int jupper,jlower,supper,slower;

	while( *sp != 0 ) {
		/* ASCII */
		if ( *sp <= 0x7f ){
			*dp++ = *sp++;
			continue;
		}
		/* Ⱦѥ */
		if ( 0xa0 <= *sp && *sp <= 0xdf ){
			sp += 2;
			mc_puts("\nȾѥʤѤƤޤ̵뤷ޤ\n\007");
			continue;
		}
		/*  */
		supper = *sp++;
		slower = *sp++;
		if(slower <= 0x9E){
			if( supper <= 0x9F )
				jupper = (supper-0x71) * 2 + 1;
			else
				jupper = (supper-0xB1) * 2 + 1;
			jlower = slower - 0x1F;
			if ( slower >= 0x80 )
				jlower--;
		} else {
			if( supper <= 0x9F )
				jupper = (supper-0x70) * 2;
			else
				jupper = (supper-0xB0) * 2;
			jlower = slower - 0x7E;
		}
		*dp++ = jupper | 0x80;
		*dp++ = jlower | 0x80;
	}
	*dp = 0;
}

/*
 * ESC Ƥղä
 */
add_esc(sp,dp)
register unsigned char *sp;		/*  JIS ʸESC Ƥ뤫 */
register unsigned char *dp;		/*  JIS ʸ */
{
	register int esc_flag = 0;

	while ( *sp != 0 ) {
		if (*sp == ESC) {
			esc_flag = 1;
			*dp++ = *sp++;
			continue;
		}
		if ( *sp == '$' && ( sp[1] == '@' || sp[1] == 'B' ) ) {
			if ( esc_flag != 1 )
				*dp++ = ESC;
			*dp++ = *sp++;
			esc_flag = 0;
			continue;
		}
		if ( *sp == '(' &&
			(sp[1] == 'B' || sp[1] == 'H' || sp[1] == 'J' ) ) {
			if ( esc_flag != 1 )
				*dp++ = ESC;
			*dp++ = *sp++;
			esc_flag = 0;
			continue;
		}
		*dp++ = *sp++;
		esc_flag = 0;
	}
	*dp = 0;
}


