/*	pathway.c	PathWay for DOS support libraly	Ver 1.01
 *
 *	бTCP/IP	The Wollongong Group: PathWay for DOS V1.1ʹ
 *			ꥳ: STARLAN TCP/IP Software V3.01ʹ
 *
 *	Copyleft(c)	1993 koba@toda.ricoh.co.jp
 *	Permit anyone to use, modify, redistribute this software.
 *	last modified at 21 Jul 1993 by koba@toda.ricoh.co.jp
 */

#if defined(MSDOS) && defined(PATHWAY)

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<dos.h>
#ifdef INTERNAL
#include <socket/types.h>
#include <socket/fcntl.h>
#include <socket/socket.h>
#include <socket/time.h>
#include <socket/in.h>
#include <socket/errno.h>
#include <socket/netdb.h>
#else
#include <sys/types.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <sys/errno.h>
#include <netdb.h>
#endif

/* grobal */	int		find_inet( void );
/* grobal */	int		soclose( int );
/* grobal */	unsigned long	inet_addr( char * );

#ifdef GNUDOS
#define	TCP_BUFF_SIZE	32768			/* Хåե	*/
#else
#define	TCP_BUFF_SIZE	(size_t)32768		/* Хåե	*/
#endif

static int	winit = 0;

int
find_inet()			/* TCP/IP Ȥ߹߳ǧ	*/
{
	if ( winit++ ) return(1);
	if ( win_init() ) {
		printf( "TCP/IP顼\n" );
		return(0);
	}
	
	if ( socket_init() ) {
		printf( "socket饤֥顼\n" );
		return(0);
	}
	return(1);
}

int
recvs( s, buf, len, flags )
int	s;
char	*buf;
int	len, flags;
{
#ifdef GNUDOS

/*
 *	Not supported
 *		- PATHWAY for DOS (TCP/IP) -
 */

#else
	int	n;
	unsigned int l;
/*	char	*mp; */
	char	*mp = "  ";

	n = 0;
/*	if ( ( mp = malloc( TCP_BUFF_SIZE ) )== NULL )	return -2; */

	while( 1 ) {
		if ( ( l = recv( s, mp, 1, 0 ) ) < 0 ) {
			if (errno != EWOULDBLOCK) {
				fprintf(stderr, "recv error: %d\n", errno );
			/*	free ( mp ); */
				return -3;
			}
		} else if ( l > 0 ) {
			if ( n < len-1) {
			  if ((buf[n++] = mp[0]) == '\n' ) {
				buf[n] = 0;
			/*	fprintf(stderr, "[%d]<<%s", n, buf ); */
			/*	free ( mp ); */
				return (int)strlen( buf );
			  }
			} else {
				buf[n] = mp[0];
				buf[n+1] = 0;
			/*	free ( mp ); */
				return (int)strlen( buf );
			}
		}
		else {
			fprintf(stderr, "recv error: len=0 %d\n", errno);
		/*	free ( mp ); */
			return -4;
		}
	}
#endif
}

int
soclose( s )
int	s;
{
	int	n;

	if ( sock_close ( s ) )		return -1;	/* Close error	*/
	return 0;
}

unsigned long
inet_addr( addr )
char	*addr;
{
	char	adrs[8], work[16];

	strncpy( work, addr, 15 );
	adrs[0] = adrs[1] = adrs[2] = adrs[3] = 0;
	adrs[0] = (char)atoi( strtok( work, "." ) );
	adrs[1] = (char)atoi( strtok( NULL, "." ) );
	adrs[2] = (char)atoi( strtok( NULL, "." ) );
	adrs[3] = (char)atoi( strtok( NULL, "\t " ) );
	return *(u_long *)adrs;
}

#endif	/* MSDOS && PATHWAY */
