/*
 * @(#)newsrc.c	1.10 Aug.6,1993
 *
 * ޤ󡣤Ūʳλѡۤ¤ߤޤ
 * (C) yamasita@omronsoft.co.jp
 */

#include	<stdio.h>
#ifdef MSDOS
#include	<stdlib.h>
#include	<string.h>
#else
extern unsigned char *strchr();
#endif

#include	"nntp.h"
#include	"gn.h"

static newsrc_make_gnus(),bad_newsrc_line();

/*
 * .newsrc ɤ߹
 */

get_newsrc()
{
	FILE *fp;
#ifdef	SAVE_MEMORY
	FILE *sfp;
#endif
	register newsgroup_t	**ng;
	unsigned char resp[NEWSRC_LEN+1];
	register unsigned char *pt;
	register unsigned char rc[NEWSRC_LEN+1];
	register int line = 0;

	/* .newsrc Υץ */
	if ( (fp = fopen(rcfile,"r")) == NULL ) {
		printf("\n%s ",rcfile);
		mc_puts("ߤĤޤ\n");
		return(-1);
	}
#ifdef	SAVE_MEMORY
	if ( ( sfp = fopen(newsrc_tmp_file,"a") ) == NULL ){
		perror(newsrc_tmp_file);
		mc_puts("ƥݥեκ˼Ԥޤ\n");
		return(FILE_WRITE_ERROR);
	}
#endif
	printf(rcfile);
	mc_puts(" ɾɤ߹Ǥޤ\n");
	ng = &newsrc;
	while( 1 ) {
		line++;
		/* ɤ߹ */
		if ( fgets(resp,NEWSRC_LEN,fp) == NULL ) {
			fclose(fp);
#ifdef	SAVE_MEMORY
			fclose(sfp);
#endif
			return(0);
		}
		strcpy(rc,resp);

		/* UNSUBSCRIBE Ƚ */
		if ( (pt = strchr(resp,':') ) != NULL ) {
			/* 塼γ */
			*ng = (newsgroup_t *)malloc(sizeof(newsgroup_t));
			(*ng)->next = 0;
			(*ng)->newsrc = 0;
			(*ng)->desc = 0;
			(*ng)->flag = 0;
		} else if ( (pt = strchr(resp,'!') ) != NULL ) {
#ifdef	SAVE_MEMORY
			fprintf(sfp,"%s",resp);	/* ƥݥե˽ */
			continue;
#else
			/* 塼γ */
			*ng = (newsgroup_t *)malloc(sizeof(newsgroup_t));
			(*ng)->next = 0;
			(*ng)->newsrc = 0;
			(*ng)->desc = 0;
			(*ng)->flag = UNSUBSCRIBE;
#endif
		} else {
			bad_newsrc_line(line,rc);
			continue;
		}

		/* ˥塼롼̾ */
		*pt = 0;
		(*ng)->name = (unsigned char *)malloc(strlen(resp)+1);
		strcpy((*ng)->name,resp);

		/* ڡɬ */
		pt++;
		if ( *pt != ' ' ) {
			if ( *pt == '\n' )
				(*ng)->read = 0;				/* ɤεʤ */
			else
				bad_newsrc_line(line,rc);
		} else {
			/*  */
			pt++;
			if ( *pt < '0' || '9' < *pt ) {
				/* ɤεʤ */
				(*ng)->read = 0;
			} else {
				/* ǽδɤεֹ */
				(*ng)->read = atol(pt);
				if ( (*ng)->read != 1) {	/* GNUS format */
					(*ng)->read = 0;
					newsrc_make_gnus(*ng,pt);
				} else {
					while( '0' <= *pt && *pt <= '9' )
						pt++;
					switch ( *pt ) {
					case '-':
						pt++;
						if ( *pt < '0' || '9' < *pt ){
							bad_newsrc_line(line,rc);
							break;
						}
						/* 1-9999 format */
						(*ng)->read = atol(pt);
						while( '0' <= *pt && *pt <= '9' )
							pt++;
						switch ( *pt ) {
						case ',':				/* GNUS format */
							pt++;
							newsrc_make_gnus(*ng,pt);
							break;
						case '\n':				/* gn format */
							break;
						default:
							bad_newsrc_line(line,rc);
							break;
						}
						break;
					case ',':				/* GNUS format */
						pt++;
							newsrc_make_gnus(*ng,pt);
						break;
					case '\n':				/* ǽεֹ椷ʤ */
						break;
					default:
						bad_newsrc_line(line,rc);
						break;
					}
				}
			}
		}
		/* Ԥ NEWSRC_LEN ʸʾξ硢ɤФ */
		while ( strchr(pt,'\n') == NULL ) {
			if ( fgets(resp,NEWSRC_LEN,fp) == NULL ) {
				fclose(fp);
				return(0);
			}
			pt = resp;
		}

		(*ng)->subj = 0;
		ng = &((*ng)->next);
	}
}

/*
 * GNUS եޥåȹԤ¸
 */
static
newsrc_make_gnus(ng,pt)
register newsgroup_t	*ng;
register unsigned char *pt;
{
	register unsigned char *pt2;

	/* .newsrc ιԤ¸ */
	ng->newsrc = (unsigned char *)malloc(strlen(pt)+1);
	strcpy(ng->newsrc,pt);
	if ( (pt2 = strchr(ng->newsrc,'\n')) != NULL )
		*pt2 = 0;
	if ( gnus_format == 0 ) {
		mc_puts("GNUS format Ȥưޤ\n");
		gnus_format = 1;
	}
}

/*
 * Ԥηٹ
 */
static
bad_newsrc_line(line,resp)
int	line;					/*  */
unsigned char *resp;		/*  */
{
	printf(rcfile);
	mc_puts(" ΥեޥåȤ˸꤬ޤ\n");
	printf("Line %d:%s\n",line,resp);
}

/*
 * .newsrc Υ
 */
void
save_newsrc()
{
	FILE *fp;
#ifdef	SAVE_MEMORY
	FILE *sfp;
	unsigned char resp[NEWSRC_LEN+1];
#endif
	register newsgroup_t	*ng;
	register unsigned char *pt;

	mc_puts("ɾ ");
	printf(rcfile);
	mc_puts(" ¸ޤ\n");

	/* .newsrc Υץ */
	if ( (fp = fopen(rcfile,"w")) == NULL ) {
		printf("\n");
		printf(rcfile);
		mc_puts(" ι˼Ԥޤ\n");
		return;
	}

#ifdef	SAVE_MEMORY
	if ( (sfp = fopen(newsrc_tmp_file,"r")) == NULL ) {
		printf("\n%s ",newsrc_tmp_file);
		mc_puts("ߤĤޤ\n");
		return;
	}
	while ( fgets(resp,NEWSRC_LEN,sfp) != NULL ) {
		fputs(resp,fp);
	}
	fclose(sfp);
#endif
	for ( ng = newsrc ; ng != 0 ; ng=ng->next) {
		fprintf(fp,"%s",ng->name);	/* ̾ */
		if ( ng->flag & UNSUBSCRIBE )	/* ɤʤ */
			fprintf(fp,"! ");
		else
			fprintf(fp,": ");
		if ( (ng->first == 0 || ng->read <= 0) && ng->newsrc == 0 ){
			fprintf(fp,"\n");
			continue;
		}
		if ( ng->read >= 1 ) {
			fprintf(fp,"1");
			if ( ng->read != 1)
				fprintf(fp,"-%ld",ng->read);
		}

		/* GNUS format  .newsrc */
		if ( gnus_format == 0 || (pt = ng->newsrc) == 0 ) {
			fprintf(fp,"\n");
			continue;
		}
		if ( ng->first == 0 || ng->read <= 0 )
			fprintf(fp,"%s\n",pt);
		else
			fprintf(fp,",%s\n",pt);
	}
	fclose(fp);
}
connection_closed()
{
	mc_puts("˥塼ФȤ³ڤޤ\nɾ ");
	printf(rcfile);
	mc_puts(" ¸λޤ\n");
	hit_return();

	save_newsrc();
	/* ǸɤмΤƤ */
	if ( last_art.tmp_file[0] != 0 )
		unlink(last_art.tmp_file);

	exit(1);
}
#ifdef	SAVE_MEMORY
make_newsrc_tmp_file()
{
	FILE *fp;

	strcpy(newsrc_tmp_file,tmpdir);
	strcat(newsrc_tmp_file,"gnXXXXXX");
	mktemp(newsrc_tmp_file);
	if ( ( fp = fopen(newsrc_tmp_file,"w") ) == NULL ){
		perror(newsrc_tmp_file);
		mc_puts("ƥݥեκ˼Ԥޤ\n");
		return(FILE_WRITE_ERROR);
	}
	fclose(fp);
}
#if 0
/* ˡϡ̤ʤä */
free_unsub_group()
{
	FILE *fp;
	register newsgroup_t **ng;
	register newsgroup_t *tmp;

	/* open tmp file */
	strcpy(newsrc_tmp_file,tmpdir);
	strcat(newsrc_tmp_file,"gnXXXXXX");
	mktemp(newsrc_tmp_file);
	if ( ( fp = fopen(newsrc_tmp_file,"w") ) == NULL ){
		perror(newsrc_tmp_file);
		mc_puts("ƥݥեκ˼Ԥޤ\n");
		return(FILE_WRITE_ERROR);
	}

	ng = &newsrc;
	while(1) {
		if ( *ng == 0 )
			break;
		if ( ((*ng)->flag & UNSUBSCRIBE) != UNSUBSCRIBE ) {
			ng = &((*ng)->next);
			continue;
		}
		tmp = (*ng); 
		*ng = (*ng)->next;
		
		fprintf(fp,"%s",tmp->name);	/* ̾ */
		fprintf(fp,"! ");
		if ( (tmp->first == 0 || tmp->read <= 0) && tmp->newsrc == 0 ){
			fprintf(fp,"\n");
			continue;
		}
		if ( tmp->read >= 1 ) {
			fprintf(fp,"1");
			if ( tmp->read != 1)
				fprintf(fp,"-%ld",tmp->read);
		}
		
		/* GNUS format  .newsrc */
		if ( gnus_format == 0 || tmp->newsrc == 0 ) {
			fprintf(fp,"\n");
			continue;
		}
		if ( tmp->first == 0 || tmp->read <= 0 )
			fprintf(fp,"%s\n",tmp->newsrc);
		else
			fprintf(fp,",%s\n",tmp->newsrc);
	}
	fclose(fp);
	return(CONT);
}
#endif
#endif
